---
title: Document.domain
slug: Web/API/Document/domain
tags:
  - API
  - Document
  - HTML DOM
  - Property
  - Reference
---
<div>{{ApiRef}}{{ Deprecated_header() }}</div>

<p>The <strong><code>domain</code></strong> property of the {{domxref("Document")}} interface gets/sets the domain portion of the {{glossary("origin")}} of the current document, as used by the <a href="/en-US/docs/Web/Security/Same-origin_policy">same-origin policy</a>.</p>

<h2 id="Syntax">Syntax</h2>

<h3 id="Getter">Getter</h3>

<pre class="syntaxbox notranslate">const <var>domainString</var> = <var>document</var>.domain</pre>

<p>The getter for this property returns the domain portion of the current document's origin. In most cases, this will be the hostname portion of the document's URL. However, there are some exceptions:</p>

<ul>
 <li>If the page has an opaque {{glossary("origin")}}, e.g. for a page with a <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs">data URL</a>, then it will return the empty string.</li>
 <li>If the <code>document.domain</code> <a href="#Setter">setter</a> has been used, then it will return the value that was set.</li>
</ul>

<p>Usually it is better to use the {{domxref("Location.hostname")}} property instead.</p>

<h3 id="Setter">Setter</h3>

<pre class="syntaxbox notranslate"><var>document</var>.domain = <var>domainString</var></pre>

<p>The setter for this property can be used to <em>change</em> a page's {{glossary("origin")}}, and thus modify how certain security checks are performed. It can only be set to the same or a parent domain. For example, if <code>https://a.example.com</code> and <code>https://b.example.com</code> both use</p>

<pre class="brush:js notranslate">document.domain = "example.com";</pre>

<p>then they have both modified their origin to have the same domain, and they can now access each other's DOM directly—despite being cross-origin, which would normally prevent such access.</p>

<p>Note that setting <code>document.domain</code> to its current value is not a no-op. It still changes the origin. For example, if one page sets</p>

<pre class="brush:js notranslate">document.domain = document.domain;</pre>

<p>then it will be counted as cross-origin from any other normally-same-origin pages that have not done the same thing.</p>

<h4 id="Deprecation">Deprecation</h4>

<p>The <code>document.domain</code> setter is deprecated. It undermines the security protections provided by the <a href="/en-US/docs/Web/Security/Same-origin_policy">same origin policy</a>, and complicates the origin model in browsers, leading to interoperability problems and security bugs.</p>

<p>Attempting to set <code>document.domain</code> is dangerous. It opens up full access to a page's DOM from <em>all</em> subdomains, which is likely not be what is intended. It also removes the port component from the origin, so now your page can be accessed by other pages with the same IP address or same host component, even on a different port.</p>

<p>This is especially insecure on shared hosting. For example, another shared hosting customer is able to host a site at the same IP address but on a different port, then setting <code>document.domain</code> will remove the same-origin protection that normally protects you from that other customer's site accessing your site's data.</p>

<p>Similar problems occur with shared hosting sites that give each customer a different subdomain. If a site sets <code>document.domain</code>, any other customer on a different subdomain can now do the same thing, and start accessing the data of the original site.</p>

<p>Instead of using <code>document.domain</code> to facilitate cross-origin communication, you should use {{domxref("Window.postMessage")}} to send an asynchronous message to the other origin. This controlled access via message-passing is much more secure than the blanket exposure of all data caused by <code>document.domain</code>.</p>

<h4 id="Failures">Failures</h4>

<p>The setter will throw a "<code>SecurityError</code>" {{domxref("DOMException")}} in several cases:</p>

<ul>
 <li>The {{httpheader('Feature-Policy/document-domain','document-domain')}} {{HTTPHeader("Feature-Policy")}} is enabled</li>
 <li>The document is inside a sandboxed {{htmlelement("iframe")}}</li>
 <li>The document has no {{glossary("browsing context")}}</li>
 <li>The document's <a href="https://html.spec.whatwg.org/multipage/origin.html#concept-origin-effective-domain">effective domain</a> is <code>null</code></li>
 <li>The given value is neither the same as the page's current hostname, nor a parent domain of it</li>
</ul>

<p>As an example of this last failure case, trying to set <code>document.domain</code> to <code>"example.org"</code> when on <code>https://example.com/</code> will throw.</p>

<p>Additionally, as part of its deprecation, it will do nothing when combined with certain modern isolation features:</p>

<ul>
 <li>If used on a cross-origin isolated page, i.e. one that uses the appropriate values for the {{httpheader("Cross-Origin-Opener-Policy")}} and {{httpheader("Cross-Origin-Embedder-Policy")}} HTTP headers</li>
 <li>If used on an origin-isolated page, i.e. one that uses the {{httpheader("Origin-Isolation")}} HTTP header</li>
</ul>

<p>Finally, setting <code>document.domain</code> does not change the origin used for origin-checks by some Web APIs, preventing sub-domain access via this mechanism. Affected APIs include (but are not limited to): {{domxref("localStorage")}}, {{domxref("indexedDB")}}, {{domxref("BroadcastChannel")}}, {{domxref("SharedWorker")}} .</p>

<h2 id="Examples">Examples</h2>

<h3 id="Getting_the_domain">Getting the domain</h3>

<p>For code running at the URL <code>http://developer.mozilla.org/en-US/docs/Web</code>, this example would set <code>currentDomain</code> to the string "<code>developer.mozilla.org</code>".</p>

<pre class="brush:js notranslate">const currentDomain = document.domain;</pre>

<p>Although the getter is not dangerous in the same way that the setter is, it is likely simpler and more useful to use the {{domxref("Location.hostname")}} property instead. Then you can avoid <code>document.domain</code> entirely:</p>

<pre class="brush:js notranslate">const currentHostname = location.hostname;</pre>

<p>For the URL <code>http://developer.mozilla.org/en-US/docs/Web</code>, <code>currentHostname</code> is also the string "<code>developer.mozilla.org</code>". Other alternatives that provide slightly different information are {{domxref("Location.host")}}, which includes the port, and {{domxref("WindowOrWorkerGlobalScope.origin")}}, which provides the full origin.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG','origin.html#relaxing-the-same-origin-restriction','document.domain')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.Document.domain")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Security/Same-origin_policy">Same-origin policy</a></li>
 <li>{{domxref("Location.hostname")}}</li>
 <li>{{domxref("Location.host")}}</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.origin")}}</li>
</ul>
